      SUBROUTINE GUOUT
*.
*...GUOUT    User routine called at the end of each event
*.
*. SEQUENCE  : GCFLAG GCONST GCLIST GCKINE TDCPAR
*.           : LPFLAG NTUPLE RCREP  XECGEO XECINT XECSCI
*. CALLS     : GDAXIS GDRAWC GDRAWT GDXYZ VZERO
*.           : HFNT   ICLRWK USOUT  XEPLEV XSBGN  XSTRAK GETTDC
*. CALLED    : GTRIG
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.11
*. CREATED   : 07-May-00
*. LAST MOD  : 18-Aug-03
*.
*. Modification Log.
*. 18-Aug-03   K.Ozone         (V1.11) Changed THRESHOLD to TDCPARS(4).
*.                             Excluded xecpmt.inc and included
*.                             tdcpar.inc
*. 11-Jun-03   K.Ozone         (V1.10) Added SIGMA{X,Y}2.
*. 10-Jun-03   K.Ozone         (V1.09) Added {X,Y}_AVERAGE, SIGMA2.
*. 06-Jun-03   K.Ozone         (V1.08) Separated time info from XDEPOS.
*. 14-Mar-03   R.Sawada        (V1.07) Enabled TDC simulation.
*. 04-Feb-03   R.Sawada        (V1.06) Enabled to trace phton from 
*.                             18.6<abs(x)<18.9, 18.6<abs(y)<18.9,
*.                             -0.3<z<0.0, 49.6<z<49.9.
*. 25-Jan-03   R.Sawada        (V1.05) Added XDEPOS(5).
*. 21-Oct-02   K.Ozone         (V1.04) LP2EXP array changed to new
*.                             assignments after BESS container works.
*.                             According to it, LP2EXP was named to
*.                             L2EOLD.
*.                             ADC #s on the top face in L2EOLD
*.                             was a right-and-left contrary.
*.                             New LP2EXP was also modified.
*. 06-Jul-02   K.Ozone         (V1.03) Changed ZFIRST to XINTR(3).
*.                             Change XDEPO to XDEPOS. Now XDEPO
*.                             means the 1st values of XDEPOS.
*.                             Added CADC in LP experiment.
*.                             Added various same sums as experiment.
*. 28-Nov-00   T.Mashimo       (V1.02) Fix a bug pointed out by Ozone;
*.                             in the event display XCONV was used
*.                             instead of X1CONV.
*. 16-May-00   T.Mashimo       (V1.01) Initial volume name MEG -> LP.
*. 07-May-00   T.Mashimo       (V1.00) 1st version based on T. Mori's
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gckine.inc"
#include "geant321/gconst.inc"
#include "geant321/gcflag.inc"
#include "geant321/gclist.inc"
#include "lpflag.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "xecsci.inc"
#include "ntuple.inc"
#include "rcrep.inc"
#include "tdcpar.inc"
*
      INTEGER I, J
      CHARACTER*35 COMMNT
*
      REAL    PSIG, XP, YP, XSQR, YSQR
*
      CHARACTER*4 CHNAMS(3)
      INTEGER LNUMBS(3)
*
      INTEGER LP2EXP(264)
      DATA    LP2EXP /
     +      48,  64,  16,   7,  55,  39,  36,  52, ! right
     +       4,  11,  59,  43,  88,  92,  96,  83,
     +      79,  75, 124, 128,  72,  67, 119, 147,
     +     180, 140, 144, 135, 131, 175, 164, 168,
     +     172, 159, 155, 151,  -1, 192, 196, 187,
     +     183,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     +      37,  53,   5,  14,  62,  46,  41,  57, ! left
     +       9,   2,  50,  34,  73,  77,  81,  94,
     +      90,  86, 145, 117,  65,  70, 126, 122,
     +     173, 129, 133, 142, 138, 178, 149, 153,
     +     157, 170, 166, 162,  -1, 181, 185, 194,
     +     190,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     +      40,  44,  76, 148, 176, 152,  -1,  -1, ! bottom
     +      56,  60,  80, 120, 132, 156, 184,  -1,
     +       8,  12,  84,  68, 136, 160, 188,  -1,
     +      15,   3,  95,  71, 143, 171, 195,  -1,
     +      63,  51,  91, 127, 139, 167, 191,  -1,
     +      47,  35,  87, 123, 179, 163,  -1,  -1,
     +      45,  33,  85, 121, 177, 161,  -1,  -1, ! top
     +      61,  49,  89, 125, 137, 165, 189,  -1,
     +      13,   1,  93,  69, 141, 169, 193,  -1,
     +       6,  10,  82,  66, 134, 158, 186,  -1,
     +      54,  58,  78, 118, 130, 154, 182,  -1,
     +      38,  42,  74, 146, 174, 150,  -1,  -1,
     +     111, 109, 107, 105, 103, 101, 113,  27, ! front
     +      23,  19,  25,  99, 115,  17,  31,  29,
     +      21,  97, 102,  22,  30,  32,  18, 100,
     +     104,  26,  20,  24,  28,  98, 106, 108,
     +     110, 112, 114, 116,  -1, 203, 201, 199, ! bottom(from 203)
     +     197,  -1, 215, 213, 211, 209, 207, 205,
     +     227, 225, 223, 221, 219, 217, 208, 206,
     +     204, 202, 200, 198, 220, 218, 216, 214,
     +     212, 210,  -1, 228, 226, 224, 222,  -1 /
      INTEGER L2EOLD(264)       ! LP2EXP before 21/Oct/2002
      DATA    L2EOLD /          ! For data before works at BESS container
                                ! in summer of 2002.
     +      48,  64,  16,   7,  55,  39,  36,  52, ! right
     +       4,  11,  59,  43,  88,  92,  96,  83,
     +      79,  75, 124, 128,  72,  67, 119, 115,
     +     180, 108, 112, 103,  99, 175, 164, 168,
     +     172, 159, 155, 151,  -1, 192, 196, 187,
     +     183,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     +      37,  53,   5,  14,  62,  46,  41,  57, ! left
     +       9,   2,  50,  34,  73,  77,  81,  94,
     +      90,  86, 113, 117,  65,  70, 126, 122,
     +     173,  97, 101, 110, 106, 178, 149, 153,
     +     157, 170, 166, 162,  -1, 181, 185, 194,
     +     190,  -1,  -1,  -1,  -1,  -1,  -1,  -1,
     +      40,  44,  76, 116, 176, 152,  -1,  -1, ! bottom
     +      56,  60,  80, 120, 100, 156, 184,  -1,
     +       8,  12,  84,  68, 104, 160, 188,  -1,
     +      15,   3,  95,  71, 111, 171, 195,  -1,
     +      63,  51,  91, 127, 107, 167, 191,  -1,
     +      47,  35,  87, 123, 179, 163,  -1,  -1,
     +      45,  33,  85, 121, 177, 161,  -1,  -1, ! top
     +      61,  49,  89, 125, 105, 165, 189,  -1,
     +      13,   1,  93,  69, 109, 169, 193,  -1,
     +       6,  10,  82,  66, 102, 158, 186,  -1,
     +      54,  58,  78, 118,  98, 154, 182,  -1,
     +      38,  42,  74, 114, 174, 150,  -1,  -1,
     +     143, 141, 139, 137, 135, 133, 145,  27, ! front
     +      23,  19,  25, 131, 147,  17,  31,  29,
     +      21, 129, 134,  22,  30,  32,  18, 132,
     +     136,  26,  20,  24,  28, 130, 138, 140,
     +     142, 144, 146, 148,  -1, 203, 201, 199, ! bottom(from 203)
     +     197,  -1, 215, 213, 211, 209, 207, 205,
     +     227, 225, 223, 221, 219, 217, 208, 206,
     +     204, 202, 200, 198, 220, 218, 216, 214,
     +     212, 210,  -1, 228, 226, 224, 222,  -1 /
*-- for 3D plot
      DATA CHNAMS / 'XPH1', 'XPH2', 'XPH3' /
      DATA LNUMBS / 1, 1, 1 /

*
*-- Draw this event
*
      IF (NPLOT .GT. 0 .AND.
     +    IEVENT .GE. LPLOT(1) .AND. IEVENT .LE. LPLOT(2)) THEN
         CALL ICLRWK(0, 0) ! clear
*-- x-z plot
         CALL GDRAWC('LP  ', 2, 3.0, 7.5, 15., 0.2, 0.2)
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
*-- y-z plot
         CALL GDRAWC('LP  ',1, 3.0, 7.5,  5., 0.2, 0.2)
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
*-- 3D plot
         CALL GDRVOL(1, CHNAMS, LNUMBS, 1,
     +               0., 0., 0., 5.5, 15., 0.12, 0.12)
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)

*-- z-x plot
*         CALL GDRAWC('LP  ', 2, 3.0, 20.0, 10., 1.0, 1.0)
*         CALL GDAXIS(-20., -20., -25., 8.)
*         CALL GDXYZ(0)
*-- output information on beam and interaction
         WRITE(COMMNT, '(''Impinged:    '',3F8.2)') (X1CONV(I),I=1,3)
         CALL GDRAWT( 5.0,  9.8, COMMNT, 0.3, 0., 2, -1)
         WRITE(COMMNT, '(''Energy:    '',3F8.2)') (X1CONV(I),I=1,3)
         CALL GDRAWT( 5.0,  9.8, COMMNT, 0.3, 0., 2, -1)
         WRITE(COMMNT, '(''Converted:   '',3F8.2)') (X1CONV(I),I=1,3)
         CALL GDRAWT( 5.0,  9.8, COMMNT, 0.3, 0., 2, -1)
         WRITE(COMMNT, '(''Interactioned:'',3F8.2)') (X1INTR(I),I=1,3)
         CALL GDRAWT( 5.0,  8.8, COMMNT, 0.3, 0., 2, -1)
      END IF
*
*-- No conversion or interaction 
*
      IF (X1INTR(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No interaction occurred'')') 
         CALL REPORT('GUOUT', 1, 'WARNING')
      END IF
      IF (X1CONV(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No conversion occurred'')') 
         CALL REPORT('GUOUT', 2, 'INFO')
      END IF
*
*-- Scintillation light tracking
*
      IF (ISCTRK .GT. 0) THEN
         CALL XSBGN
         DO 100 I = 1, NDEXE
            IF (XDEXE(1,I) .GT. (WALL(1)-0.3) .AND.
     +          XDEXE(1,I) .LT. (WALL(2)+0.3) .AND.
     +          XDEXE(2,I) .GT. (WALL(3)-0.3) .AND.
     +          XDEXE(2,I) .LT. (WALL(4)+0.3) .AND.
     +          XDEXE(3,I) .GT. (WALL(5)-0.3) .AND.
     +          XDEXE(3,I) .LT. (WALL(6)+0.3)) THEN
               NDEXES = NDEXES + 1
               CALL XSTRAK(XDEXE(1,I))
            END IF
  100    CONTINUE
      END IF
*
*-- Print the p.e. distribution graphically
*
**    CALL XEPLEV
*
*-- Fill ntuple
*
      IF (NTUPON .EQ. 1) THEN
         DEXE   = DEXESM
         DEPMT  = DEREST
         XCONV(1) = X1CONV(1)
         XCONV(2) = X1CONV(2)
         XCONV(3) = X1CONV(3)
         XINTR(1) = X1INTR(1)
         XINTR(2) = X1INTR(2)
         XINTR(3) = X1INTR(3)
         NDEPO  = NDEXE
         DO 210 I = 1, NDEPO
            DO 210 J = 1, 5
               XDEPOS(J,I) = XDEXE(J,I)
 210        CONTINUE
         XDEPO(1) = XDEPOS(1,1)
         XDEPO(2) = XDEPOS(2,1)
         XDEPO(3) = XDEPOS(3,1)
         XDEPO(4) = XDEPOS(4,1)
         XDEPT    = XDEPTS(1)
         NTOTPE = NPEGEN
         NSUM   = NPEALL
         DO 220 I = 1, NALPMT
            NPE(I) = NPEPMT(I)
 220     CONTINUE
         IF (EXPOUT .EQ. 1) THEN
            Q_RIGHT  = FLOAT(NPEWAL(1) - NPE(37) - NPE(42) - NPE(43)
     +           - NPE(44)- NPE(45) - NPE(46) - NPE(47) - NPE(48))
            Q_LEFT   = FLOAT(NPEWAL(2) - NPE(85) - NPE(90) - NPE(91)
     +           - NPE(92) - NPE(93) - NPE(94) - NPE(95) - NPE(96))
            Q_BOTTOM = FLOAT(NPEWAL(3) - NPE(143) - NPE(103) - NPE(104)
     +           - NPE(112) - NPE(120) - NPE(128) - NPE(136) - NPE(144))
            Q_TOP    = FLOAT(NPEWAL(4) - NPE(151) - NPE(152) - NPE(160)
     +           - NPE(168) - NPE(176) - NPE(184) - NPE(192) - NPE(191))
            Q_FRONT  = FLOAT(NPEWAL(5))
            Q_BACK   = FLOAT(NPEWAL(6) - NPE(229) - NPE(234) - NPE(259)
     +            - NPE(264))
            QSUM     = Q_RIGHT + Q_LEFT + Q_BOTTOM + Q_TOP
     +           + Q_FRONT + Q_BACK
            DO 230 I = 1, 264
               IF (LP2EXP(I) .NE. -1) THEN                  
                  CADC(LP2EXP(I)) = FLOAT(NPE(I))
               END IF
 230        CONTINUE
*
            X_AVERAGE = 0.0
            Y_AVERAGE = 0.0
            XSQR = 0.0
            YSQR = 0.0
            IF (NPEWAL(5) .GT. 0) THEN
               DO 237 I = 1, 6
                  DO 233 J = 1, 6
                     PSIG = FLOAT(NPE(235 - J - (I*6)))
                     XP = 21.7 - 6.2 * J
                     YP = 21.7 - 6.2 * I
                     X_AVERAGE = X_AVERAGE + PSIG * XP
                     Y_AVERAGE = Y_AVERAGE + PSIG * YP
                     XSQR = XSQR + PSIG * XP * XP
                     YSQR = YSQR + PSIG * YP * YP
 233              CONTINUE
 237           CONTINUE
               X_AVERAGE = X_AVERAGE / NPEWAL(5)
               Y_AVERAGE = Y_AVERAGE / NPEWAL(5)
               XSQR = XSQR / NPEWAL(5)
               YSQR = YSQR / NPEWAL(5)
               SIGMAX2 = XSQR - X_AVERAGE*X_AVERAGE
               SIGMAY2 = YSQR - Y_AVERAGE*Y_AVERAGE
               SIGMA2 = (SIGMAX2 + SIGMAY2)/2.
            ELSE
               X_AVERAGE = 0.0
               Y_AVERAGE = 0.0
               SIGMA2    = 0.0
            END IF
         END IF
         DO 240 I = 1, NWALL
            NPEW(I) = NPEWAL(I)
 240     CONTINUE
*
         IF(TDCOUT .NE. 0) THEN
            CALL VZERO(TDC,264)
            DO 280 I=1,264
               IF ((LP2EXP(I) .LE. 128) .AND.
     +              (NPE(I) .GT. TDCPARS(4)/PEAKVOLT) .AND.
     +              (NPE(I) .LE. 20000)
     +              ) THEN
                  CALL GETTDC(I)
               END IF
 280        CONTINUE
         END IF
*
         CALL HFNT(IDNTPL)
      END IF
*
*-- Call user routine
*
      CALL USOUT
*
      RETURN
      END
